!SURFEX_LIC Copyright 1994-2014 Meteo-France 
!SURFEX_LIC This is part of the SURFEX software governed by the CeCILL-C  licence
!SURFEX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!SURFEX_LIC for details. version 1.
!     #################################################################################
SUBROUTINE DEALLOC_SURFEX
!     #################################################################################
!
!!****  *DEALLOC_SURFEX * - Deallocate  the surfaces
!!
!!    PURPOSE
!!    -------
!
!!**  METHOD
!!    ------
!!
!!    REFERENCE
!!    ---------
!!      
!!
!!    AUTHOR
!!    ------
!!     R. El Khatib
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    04/2010
!!------------------------------------------------------------------
!
USE MODD_AGRI_n,   ONLY : AGRI_DEALLO
USE MODD_CH_EMIS_FIELD_n,   ONLY : CH_EMIS_FIELD_DEALLO
USE MODD_CH_SNAP_n,   ONLY : CH_EMIS_SNAP_DEALLO
USE MODD_CH_ISBA_n,   ONLY : CH_ISBA_DEALLO
USE MODD_CH_SEAFLUX_n,   ONLY : CH_SEAFLUX_DEALLO
USE MODD_CH_SURF_n,   ONLY : CH_SURF_DEALLO
USE MODD_CH_TEB_n,   ONLY : CH_TEB_DEALLO
USE MODD_CH_WATFLUX_n,   ONLY : CH_WATFLUX_DEALLO
USE MODD_DATA_ISBA_n,   ONLY : DATA_ISBA_DEALLO
USE MODD_DATA_TSZ0_n,   ONLY : DATA_TSZ0_DEALLO
USE MODD_DATA_SEAFLUX_n,   ONLY : DATA_SEAFLUX_DEALLO
USE MODD_DATA_TEB_GARDEN_n,   ONLY : DATA_TEB_GARDEN_DEALLO
USE MODD_DATA_TEB_GREENROOF_n,   ONLY : DATA_TEB_GREENROOF_DEALLO
USE MODD_DATA_TEB_n,   ONLY : DATA_TEB_DEALLO
USE MODD_BLD_DESCRIPTION,   ONLY : BLD_DESC_DEALLO
USE MODD_DATA_BEM_n,   ONLY : DATA_BEM_DEALLO
USE MODD_DIAG_EVAP_ISBA_n,   ONLY : DIAG_EVAP_ISBA_DEALLO
USE MODD_DIAG_FLAKE_n,   ONLY : DIAG_FLAKE_DEALLO
USE MODD_DIAG_IDEAL_n,   ONLY : DIAG_IDEAL_DEALLO
USE MODD_DIAG_ISBA_n,   ONLY : DIAG_ISBA_DEALLO
USE MODD_DIAG_MISC_FLAKE_n,   ONLY : DIAG_MISC_FLAKE_DEALLO
USE MODD_DIAG_MISC_ISBA_n,   ONLY : DIAG_MISC_ISBA_DEALLO
USE MODD_DIAG_MISC_TEB_n,   ONLY : DIAG_MISC_TEB_DEALLO, DIAG_MISC_TEB_OPTIONS_DEALLO
USE MODD_DIAG_UTCI_TEB_n,   ONLY : DIAG_UTCI_TEB_DEALLO
USE MODD_DIAG_OCEAN_n,   ONLY : DIAG_OCEAN_DEALLO
USE MODD_DIAG_SEAFLUX_n,   ONLY : DIAG_SEAFLUX_DEALLO
USE MODD_DIAG_SURF_ATM_n,   ONLY : DIAG_SURF_ATM_DEALLO
USE MODD_DIAG_TEB_n,   ONLY : DIAG_TEB_DEALLO
USE MODD_DIAG_WATFLUX_n,   ONLY : DIAG_WATFLUX_DEALLO
USE MODD_DST_n,   ONLY : DST_DEALLO
USE MODD_DUMMY_SURF_FIELDS_n,   ONLY : DUMMY_SURF_FIELDS_DEALLO
USE MODD_EMIS_GR_FIELD_n,   ONLY : EMIS_GR_FIELD_DEALLO
USE MODD_FLAKE_GRID_n,   ONLY : FLAKE_GRID_DEALLO
USE MODD_FLAKE_n,   ONLY : FLAKE_DEALLO
USE MODD_FLAKE_SBL_n,   ONLY : FLAKE_SBL_DEALLO
USE MODD_GR_BIOG_GARDEN_n,   ONLY : GR_BIOG_GARDEN_DEALLO
USE MODD_GR_BIOG_n,   ONLY : GR_BIOG_DEALLO
USE MODD_IDEAL_n,   ONLY : IDEAL_DEALLO
USE MODD_IO_BUFF_n,   ONLY : IO_BUFF_DEALLO
USE MODD_ISBA_CANOPY_n,   ONLY : ISBA_CANOPY_DEALLO
USE MODD_ISBA_GRID_n,   ONLY : ISBA_GRID_DEALLO
USE MODD_ISBA_n,   ONLY : ISBA_DEALLO
USE MODD_OCEAN_GRID_n,   ONLY : OCEAN_GRID_DEALLO
USE MODD_OCEAN_n,   ONLY : OCEAN_DEALLO
USE MODD_OCEAN_REL_n,   ONLY : OCEAN_REL_DEALLO
USE MODD_SEAFLUX_GRID_n,   ONLY : SEAFLUX_GRID_DEALLO
USE MODD_SEAFLUX_n,   ONLY : SEAFLUX_DEALLO
USE MODD_SEAFLUX_SBL_n,   ONLY : SEAFLUX_SBL_DEALLO
USE MODD_SLT_n,   ONLY : SLT_DEALLO
USE MODD_SURF_ATM_GRID_n,   ONLY : SURF_ATM_GRID_DEALLO
USE MODD_SURF_ATM_n,   ONLY : SURF_ATM_DEALLO
USE MODD_SURF_ATM_SSO_n,   ONLY : SURF_ATM_SSO_DEALLO
USE MODD_DATA_COVER_n,   ONLY : DATA_COVER_DEALLO
USE MODD_SV_n,   ONLY : SV_DEALLO
USE MODD_SSO_CANOPY_n,   ONLY : SSO_CANOPY_DEALLO
USE MODD_TEB_CANOPY_n,   ONLY : TEB_CANOPY_DEALLO
USE MODD_TEB_GARDEN_n,   ONLY : TEB_GARDEN_DEALLO, TEB_GARDEN_OPTIONS_DEALLO,&
                                TEB_GARDEN_PGD_DEALLO, TEB_GARDEN_PGD_EVOL_DEALLO
USE MODD_TEB_GRID_n,   ONLY : TEB_GRID_DEALLO
USE MODD_TEB_n,   ONLY : TEB_DEALLO, TEB_OPTIONS_DEALLO
USE MODD_TEB_VEG_n,   ONLY : TEB_VEG_OPTIONS_DEALLO
USE MODD_BEM_n,   ONLY : BEM_DEALLO, BEM_OPTIONS_DEALLO
USE MODD_TEB_GREENROOF_n,   ONLY : TEB_GREENROOF_OPTIONS_DEALLO, &
                                   TEB_GREENROOF_PGD_DEALLO,     &
                                   TEB_GREENROOF_PGD_EVOL_DEALLO,&
                                   TEB_GREENROOF_DEALLO
USE MODD_WATFLUX_GRID_n,   ONLY : WATFLUX_GRID_DEALLO
USE MODD_WATFLUX_n,   ONLY : WATFLUX_DEALLO
USE MODD_WATFLUX_SBL_n,   ONLY : WATFLUX_SBL_DEALLO
USE MODD_DIAG_TRIP_n,   ONLY : DIAG_TRIP_DEALLO
USE MODD_TRIP_GRID_n,   ONLY : TRIP_GRID_DEALLO
USE MODD_TRIP_n,   ONLY : TRIP_DEALLO

USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
!*      0.1    declarations of arguments
!
!
!*      0.2    declarations of local variables
!
!-------------------------------------------------------------------------------------
!
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('DEALLOC_SURFEX',0,ZHOOK_HANDLE)
 CALL AGRI_DEALLO
 CALL CH_EMIS_FIELD_DEALLO
 CALL CH_EMIS_SNAP_DEALLO
 CALL CH_ISBA_DEALLO
 CALL CH_SEAFLUX_DEALLO
 CALL CH_SURF_DEALLO
 CALL CH_TEB_DEALLO
 CALL CH_WATFLUX_DEALLO
 CALL DATA_ISBA_DEALLO
 CALL DATA_SEAFLUX_DEALLO
 CALL DATA_TEB_GARDEN_DEALLO
 CALL DATA_TEB_GREENROOF_DEALLO
 CALL DATA_TEB_DEALLO
 CALL DATA_BEM_DEALLO
 CALL BLD_DESC_DEALLO
 CALL DIAG_EVAP_ISBA_DEALLO
 CALL DIAG_FLAKE_DEALLO
 CALL DIAG_IDEAL_DEALLO
 CALL DIAG_ISBA_DEALLO
 CALL DATA_TSZ0_DEALLO
 CALL DIAG_MISC_FLAKE_DEALLO
 CALL DIAG_MISC_ISBA_DEALLO
 CALL DIAG_MISC_TEB_DEALLO
 CALL DIAG_MISC_TEB_OPTIONS_DEALLO
 CALL DIAG_UTCI_TEB_DEALLO
 CALL DIAG_OCEAN_DEALLO
 CALL DIAG_SEAFLUX_DEALLO
 CALL DIAG_SURF_ATM_DEALLO
 CALL DIAG_TEB_DEALLO
 CALL DIAG_WATFLUX_DEALLO
 CALL DST_DEALLO
 CALL DUMMY_SURF_FIELDS_DEALLO
 CALL EMIS_GR_FIELD_DEALLO
 CALL FLAKE_GRID_DEALLO
 CALL FLAKE_DEALLO
 CALL FLAKE_SBL_DEALLO
 CALL GR_BIOG_GARDEN_DEALLO
 CALL GR_BIOG_DEALLO
 CALL IDEAL_DEALLO
 CALL IO_BUFF_DEALLO
 CALL ISBA_CANOPY_DEALLO
 CALL ISBA_GRID_DEALLO
 CALL ISBA_DEALLO
 CALL OCEAN_GRID_DEALLO
 CALL OCEAN_DEALLO
 CALL OCEAN_REL_DEALLO
 CALL SEAFLUX_GRID_DEALLO
 CALL SEAFLUX_DEALLO
 CALL SEAFLUX_SBL_DEALLO
 CALL SLT_DEALLO
 CALL SURF_ATM_GRID_DEALLO
 CALL SURF_ATM_DEALLO
 CALL SURF_ATM_SSO_DEALLO
 CALL DATA_COVER_DEALLO
 CALL SV_DEALLO
 CALL SSO_CANOPY_DEALLO
 CALL TEB_CANOPY_DEALLO
 CALL TEB_GARDEN_DEALLO
 CALL TEB_GARDEN_PGD_DEALLO
 CALL TEB_GARDEN_PGD_EVOL_DEALLO
 CALL TEB_GARDEN_OPTIONS_DEALLO
 CALL TEB_GRID_DEALLO
 CALL TEB_DEALLO
 CALL TEB_OPTIONS_DEALLO
 CALL TEB_VEG_OPTIONS_DEALLO
 CALL BEM_DEALLO
 CALL BEM_OPTIONS_DEALLO
 CALL TEB_GREENROOF_OPTIONS_DEALLO
 CALL TEB_GREENROOF_PGD_DEALLO
 CALL TEB_GREENROOF_PGD_EVOL_DEALLO
 CALL TEB_GREENROOF_DEALLO
 CALL WATFLUX_GRID_DEALLO
 CALL WATFLUX_DEALLO
 CALL WATFLUX_SBL_DEALLO
 CALL DIAG_TRIP_DEALLO
 CALL TRIP_GRID_DEALLO
 CALL TRIP_DEALLO
IF (LHOOK) CALL DR_HOOK('DEALLOC_SURFEX',1,ZHOOK_HANDLE)
!
!--------------------------------------------------------------------------------------
!
END SUBROUTINE DEALLOC_SURFEX
