!SURFEX_LIC Copyright 1994-2014 Meteo-France 
!SURFEX_LIC This is part of the SURFEX software governed by the CeCILL-C  licence
!SURFEX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!SURFEX_LIC for details. version 1.
!     ##################
      MODULE MODN_TEB_n
!     ##################
!
!!****  *MODN_TEB_n* - declaration of namelist NAM_TEBn
!!
!!    PURPOSE
!!    -------
!       The purpose of this module is to specify  the namelist NAM_TEBn
!
!!
!!**  IMPLICIT ARGUMENTS
!!    ------------------
!!
!!    REFERENCE
!!    ---------
!!
!!       
!!    AUTHOR
!!    ------
!!	V. Masson    *Meteo France*
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    01/2004                   
!!      Modified    10/2004 by P. Le Moigne: miscellaneous switch
!!      Modified    07/2007 by P. Le Moigne: minimum wind speed and/or shear
!!      Modified    08/2009 by B. Decharme : LSURF_BUDGETC for all tiles
!!      Modified    08/2012 by G. Pigeon : CH_BEM for conv. coef option
!-------------------------------------------------------------------------------
!
!*       0.   DECLARATIONS
!             ------------
!
USE MODD_DIAG_MISC_TEB_n, ONLY:                 &
           LSURF_MISC_BUDGET_n => LSURF_MISC_BUDGET
USE MODD_DIAG_TEB_n, ONLY:                      &
           XDIAG_TSTEP_n => XDIAG_TSTEP,        &
           N2M_n => N2M,                        &
           L2M_MIN_ZS_n => L2M_MIN_ZS,          &
           LPGD_n => LPGD,                      &
           LPGD_FIX_n => LPGD_FIX,              &
           LSURF_BUDGET_n => LSURF_BUDGET,      &
           LRAD_BUDGET_n => LRAD_BUDGET,        &
           LCOEF_n => LCOEF,                    &
           LSURF_VARS_n => LSURF_VARS
USE MODD_DIAG_UTCI_TEB_n, ONLY :                &
           LUTCI_n => LUTCI  
USE MODD_TEB_n, ONLY:                           &
           XTSTEP_n => XTSTEP,                  &
           XOUT_TSTEP_n => XOUT_TSTEP,          &
           CZ0H_n => CZ0H,                      &
           CCH_BEM_n => CCH_BEM
USE MODD_CH_TEB_n, ONLY:                        &
           CCH_DRY_DEP_n => CCH_DRY_DEP  
!
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
LOGICAL           :: LPGD
LOGICAL           :: LPGD_FIX
LOGICAL           :: L2M_MIN_ZS         
LOGICAL           :: LSURF_BUDGET
LOGICAL           :: LRAD_BUDGET
LOGICAL           :: LCOEF
LOGICAL           :: LSURF_VARS
LOGICAL           :: LSURF_MISC_BUDGET
LOGICAL           :: LUTCI
LOGICAL           :: LSURF_BUDGETC
LOGICAL           :: LRESET_BUDGETC
!
 CHARACTER(LEN=6)  :: CCH_DRY_DEP
 CHARACTER(LEN=6)  :: CZ0H
 CHARACTER(LEN=5)  :: CCH_BEM
!
REAL              :: XTSTEP
REAL              :: XOUT_TSTEP
REAL              :: XDIAG_TSTEP
!
INTEGER           :: N2M
!
NAMELIST/NAM_DIAG_SURFn/N2M,L2M_MIN_ZS,LSURF_BUDGET,LRAD_BUDGET, &
                        LCOEF,LSURF_VARS, LSURF_BUDGETC, LRESET_BUDGETC
!
NAMELIST/NAM_CH_TEBn/CCH_DRY_DEP
NAMELIST/NAM_DIAG_TEBn/LPGD,LPGD_FIX,LSURF_MISC_BUDGET,LUTCI
NAMELIST/NAM_TEBn/CZ0H,CCH_BEM
!
CONTAINS
!
SUBROUTINE INIT_NAM_DIAG_SURFn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_TEB_N:INIT_NAM_DIAG_SURFN',0,ZHOOK_HANDLE)
  XTSTEP = XTSTEP_n
  XOUT_TSTEP = XOUT_TSTEP_n  
  XDIAG_TSTEP = XDIAG_TSTEP_n  
  N2M = N2M_n
  L2M_MIN_ZS = L2M_MIN_ZS_n
  LSURF_BUDGET = LSURF_BUDGET_n
  LRAD_BUDGET = LRAD_BUDGET_n
  LCOEF = LCOEF_n
  LSURF_VARS = LSURF_VARS_n
IF (LHOOK) CALL DR_HOOK('MODN_TEB_N:INIT_NAM_DIAG_SURFN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_DIAG_SURFn

SUBROUTINE UPDATE_NAM_DIAG_SURFn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_TEB_N:UPDATE_NAM_DIAG_SURFN',0,ZHOOK_HANDLE)
  XDIAG_TSTEP_n = XDIAG_TSTEP  
  N2M_n = N2M
  L2M_MIN_ZS_n = L2M_MIN_ZS
  LSURF_BUDGET_n = LSURF_BUDGET
  LRAD_BUDGET_n = LRAD_BUDGET 
  LCOEF_n = LCOEF
  LSURF_VARS_n = LSURF_VARS
IF (LHOOK) CALL DR_HOOK('MODN_TEB_N:UPDATE_NAM_DIAG_SURFN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_DIAG_SURFn
!
SUBROUTINE INIT_NAM_TEBn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_TEB_N:INIT_NAM_TEBN',0,ZHOOK_HANDLE)
  CZ0H = CZ0H_n
  CCH_BEM = CCH_BEM_n
IF (LHOOK) CALL DR_HOOK('MODN_TEB_N:INIT_NAM_TEBN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_TEBn

SUBROUTINE UPDATE_NAM_TEBn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_TEB_N:UPDATE_NAM_TEBN',0,ZHOOK_HANDLE)
  XTSTEP_n = XTSTEP
  XOUT_TSTEP_n = XOUT_TSTEP    
  CZ0H_n = CZ0H
  CCH_BEM_n = CCH_BEM
IF (LHOOK) CALL DR_HOOK('MODN_TEB_N:UPDATE_NAM_TEBN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_TEBn

SUBROUTINE INIT_NAM_CH_TEBn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_TEB_N:INIT_NAM_CH_TEBN',0,ZHOOK_HANDLE)
  CCH_DRY_DEP = CCH_DRY_DEP_n
IF (LHOOK) CALL DR_HOOK('MODN_TEB_N:INIT_NAM_CH_TEBN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_CH_TEBn

SUBROUTINE UPDATE_NAM_CH_TEBn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_TEB_N:UPDATE_NAM_CH_TEBN',0,ZHOOK_HANDLE)
  CCH_DRY_DEP_n = CCH_DRY_DEP
IF (LHOOK) CALL DR_HOOK('MODN_TEB_N:UPDATE_NAM_CH_TEBN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_CH_TEBn

SUBROUTINE INIT_NAM_DIAG_TEBn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_TEB_N:INIT_NAM_DIAG_TEBN',0,ZHOOK_HANDLE)
  LPGD = LPGD_n
  LPGD_FIX = LPGD_FIX_n
  LSURF_MISC_BUDGET = LSURF_MISC_BUDGET_n
  LUTCI = LUTCI_n
IF (LHOOK) CALL DR_HOOK('MODN_TEB_N:INIT_NAM_DIAG_TEBN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_DIAG_TEBn

SUBROUTINE UPDATE_NAM_DIAG_TEBn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_TEB_N:UPDATE_NAM_DIAG_TEBN',0,ZHOOK_HANDLE)
  LPGD_n = LPGD
  LPGD_FIX_n = LPGD_FIX
  LSURF_MISC_BUDGET_n = LSURF_MISC_BUDGET
  LUTCI_n = LUTCI
IF (LHOOK) CALL DR_HOOK('MODN_TEB_N:UPDATE_NAM_DIAG_TEBN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_DIAG_TEBn

END MODULE MODN_TEB_n
