!SURFEX_LIC Copyright 1994-2014 Meteo-France 
!SURFEX_LIC This is part of the SURFEX software governed by the CeCILL-C  licence
!SURFEX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!SURFEX_LIC for details. version 1.
!     #########
SUBROUTINE PACK_ISBA_PATCH_GET_SIZE_n
!##############################################
!
!
!!****  *PACK_ISBA_PATCH_GET_SIZE_n * - packs ISBA variables
!!
!!    PURPOSE
!!    -------
!
!!**  METHOD
!!    ------
!!
!!    REFERENCE
!!    ---------
!!      
!!
!!    AUTHOR
!!    ------
!!     V. Masson and A. boone
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    01/2004
!!      B. Decharme    2008 floodplains
!!      B. Decharme 01/2009 Good dim for XP_TG
!!      A.L. Gibelin 04/2009 : BIOMASS and RESP_BIOMASS arrays 
!!      A.L. Gibelin 04/2009 : TAU_WOOD for NCB option 
!!      A.L. Gibelin 05/2009 : Add carbon spinup
!!      A.L. Gibelin 06/2009 : Soil carbon variables for CNT option
!!      A.L. Gibelin 07/2009 : Suppress RDK and transform GPP as a diagnostic
!!      A.L. Gibelin 07/2009 : Suppress PPST and PPSTF as outputs
!!
!!------------------------------------------------------------------
!
USE MODD_DATA_COVER_PAR,  ONLY : NVEGTYPE
!
USE MODD_ISBA_n,      ONLY : TSNOW, LGLACIER, CSCOND, CISBA, CPHOTO, CRESPSL, CRAIN, LTR_ML         
USE MODD_AGRI,        ONLY : LAGRIP
!
USE MODD_PACK_ISBA,  ONLY :    NSIZE_LSIMPLE, NSIZE_L0, NSIZE_TSIMPLE, NSIZE_T0, NSIZE_SIMPLE,   &
                               NSIZE_GROUND, NSIZE_VEGTYPE, NSIZE_TG, NSIZE_SNOW, NSIZE_ALB,     &
                               NSIZE_2, NSIZE_BIOMASS, NSIZE_SOILCARB, NSIZE_LITTLEVS,           &
                               NSIZE_LITTER, NSIZE_0, NSIZE_00, NSIZE_000, NSIZE_01,             & 
                               NSIZE_NSIMPLE, NSIZE_N0 
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
REAL(KIND=JPRB) :: ZHOOK_HANDLE
!------------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('PACK_ISBA_PATCH_GET_SIZE_N',0,ZHOOK_HANDLE)
!
NSIZE_LSIMPLE=0
NSIZE_L0=0
!
NSIZE_NSIMPLE=0
NSIZE_N0=0
!
NSIZE_TSIMPLE=0
NSIZE_T0=0
!
NSIZE_SIMPLE=68
NSIZE_GROUND=11
NSIZE_VEGTYPE=1
NSIZE_TG=1
NSIZE_SNOW=2
NSIZE_ALB=2
NSIZE_2=0
NSIZE_BIOMASS=0
NSIZE_LITTER=0
NSIZE_SOILCARB=0
NSIZE_LITTLEVS=0
!
NSIZE_0=0
NSIZE_00=0
NSIZE_000=0
NSIZE_01=0
!
IF (TSNOW%SCHEME=='EBA') THEN
  NSIZE_SIMPLE=NSIZE_SIMPLE+1
ELSE 
  NSIZE_0=NSIZE_0+1
ENDIF
!
IF (TSNOW%SCHEME=='3-L' .OR. TSNOW%SCHEME=='CRO') THEN
  NSIZE_SIMPLE=NSIZE_SIMPLE+1 
  NSIZE_SNOW=NSIZE_SNOW+1 
ELSE
  NSIZE_00=NSIZE_00+1
  NSIZE_0=NSIZE_0+1
ENDIF
!
IF(TSNOW%SCHEME=='CRO') THEN
  NSIZE_SNOW=NSIZE_SNOW+4
ELSE
  NSIZE_00=NSIZE_00+4
ENDIF
!
IF(LGLACIER) THEN
  NSIZE_SIMPLE=NSIZE_SIMPLE+1
ELSE
  NSIZE_0=NSIZE_0+1
ENDIF
!
IF (CSCOND=='PL98'.OR.CISBA=='DIF') THEN
  NSIZE_GROUND=NSIZE_GROUND+1
ELSE
  NSIZE_01=NSIZE_01+1
ENDIF
!
IF (CSCOND=='PL98') THEN
  NSIZE_GROUND=NSIZE_GROUND+2
ELSE
  NSIZE_01=NSIZE_01+2
ENDIF
!
IF (CISBA=='2-L' .OR. CISBA=='3-L') THEN
  NSIZE_SIMPLE=NSIZE_SIMPLE+7
  NSIZE_2=NSIZE_2+1
ELSE
  NSIZE_0=NSIZE_0+7
  NSIZE_00=NSIZE_00+1
ENDIF
!
IF (CISBA=='DIF') THEN
  NSIZE_GROUND=NSIZE_GROUND+4
  NSIZE_NSIMPLE=NSIZE_NSIMPLE+1
ELSE
  NSIZE_01=NSIZE_01+4
  NSIZE_N0=NSIZE_N0+1
ENDIF
!
IF (LTR_ML) THEN
  NSIZE_SIMPLE = NSIZE_SIMPLE+4
ELSE
  NSIZE_0 = NSIZE_0+4
ENDIF
!
IF (CPHOTO=='NON') THEN
  NSIZE_SIMPLE=NSIZE_SIMPLE+1
ELSE
  NSIZE_0 = NSIZE_0+1
ENDIF
!
IF (CPHOTO/='NON') THEN
  NSIZE_SIMPLE=NSIZE_SIMPLE+23
  NSIZE_BIOMASS=NSIZE_BIOMASS+2
ELSE
  NSIZE_0=NSIZE_0+23
  NSIZE_00=NSIZE_00+2
ENDIF
!
IF (CPHOTO=='AST' .OR. CPHOTO=='LST' .OR. CPHOTO=='NIT' .OR. CPHOTO=='NCB') THEN
  NSIZE_LSIMPLE=NSIZE_LSIMPLE+1
  NSIZE_SIMPLE=NSIZE_SIMPLE+4
ELSE
  NSIZE_L0=NSIZE_L0+1
  NSIZE_0=NSIZE_0+4
ENDIF
!
IF (CPHOTO=='LAI' .OR. CPHOTO=='LST' .OR. CPHOTO=='NIT' .OR. CPHOTO=='NCB') THEN
  NSIZE_SIMPLE=NSIZE_SIMPLE+2
  NSIZE_TSIMPLE=NSIZE_TSIMPLE+2
  IF (LAGRIP) THEN
    NSIZE_LSIMPLE=NSIZE_LSIMPLE+2
    NSIZE_SIMPLE=NSIZE_SIMPLE+1
  ELSE
    NSIZE_L0=NSIZE_L0+2
    NSIZE_0=NSIZE_0+1
 ENDIF
ELSE
  NSIZE_L0=NSIZE_L0+2
  NSIZE_0=NSIZE_0+3
  NSIZE_T0=NSIZE_T0+2
ENDIF
!
IF(CPHOTO=='NIT' .OR. CPHOTO=='NCB') THEN
  NSIZE_SIMPLE=NSIZE_SIMPLE+4
ELSE
  NSIZE_0=NSIZE_0+4
ENDIF
!
IF (CPHOTO=='NCB') THEN
  NSIZE_BIOMASS=NSIZE_BIOMASS+1
  NSIZE_SIMPLE=NSIZE_SIMPLE+1
ELSE
  NSIZE_00=NSIZE_00+1
  NSIZE_0=NSIZE_0+1
ENDIF
!
IF (CRESPSL=='CNT') THEN
  NSIZE_LITTER=NSIZE_LITTER+1
  NSIZE_SOILCARB=NSIZE_SOILCARB+1
  NSIZE_LITTLEVS=NSIZE_LITTLEVS+1
  NSIZE_BIOMASS=NSIZE_BIOMASS+1
ELSE
  NSIZE_000=NSIZE_000+1
  NSIZE_00=NSIZE_00+3
ENDIF
!
IF (CRAIN=='SGH') THEN
  NSIZE_SIMPLE=NSIZE_SIMPLE+1
ELSE
  NSIZE_0=NSIZE_0+1
ENDIF
!
IF (LHOOK) CALL DR_HOOK('PACK_ISBA_PATCH_GET_SIZE_N',1,ZHOOK_HANDLE)
!------------------------------------------------------------------------
END SUBROUTINE PACK_ISBA_PATCH_GET_SIZE_n
